/*
 GAMP - (c) 2001 - Renato R. Santana <rrsantana@yahoo.com>
 
 This file includes definitions for the play control system. 
   
 This file is part of GAMP, the GNU Amiga Module Player
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
    
 You should have received a copy of the GNU General Public License
 along with This program; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* general mod controls */
struct modctl {
	int		pos;				/* current pos in the song arrangement */
	int		maxpos;				/* song length - 1 */
	int		row;				/* current row in the pattern */
    int     bpm;				/* Current beats Per Minute */
    int     speed;				/* Current number of mod ticks per row */
    int     hertz;				/* Frequency (in hertz) of the current BPM */
	int		pal_vblank_speed;	/* how many system ticks per vblank frequency */
	int		tick;				/* current mod tick */
	int		leaving_block;		/* when set tells the we are gonna leave the pattern */
	int		loop;				/* when set tells we play in infinite loop */
	int		volume;				/* our general sound volume  (0-100)*/
	int		stop;				/* a flag to tell when to stop */
};

/* 
* This structure holds the data for what is playing on it channel.
* 
*/
									
struct channeltype  {
    int     		current_period;
	int				final_period;
	int				instr;
    int     		instr_len;
	int				instr_reppos;
	int				instr_replen;
    char 			*p_instr_data;
    int     		playing_pos;
	int				rep_playing_pos;
	int				loudness;
	int				effect;
	int				effect_argx;
	int				effect_argy;
	int				effect_arp_orig_period_idx;
	int				effect_arp_ctr;
	int				effect_note_to_porta_to;
	int				effect_porta_speed;
	int				effect_porta_down_speed;
	int				effect_porta_up_speed;
	int				effect_vibrato_base_period;
	int				effect_vibrato_speed;
	int				effect_vibrato_depth;
	int				effect_vibrato_neg;
	int				effect_vibrato_idx;
	int				effect_tremolo_base_vol;
	int				effect_tremolo_speed;
	int				effect_tremolo_depth;
	int				effect_tremolo_neg;
	int				effect_tremolo_idx;
	int 			freq_corrector;
	int				final_volume;
};

